/* BarCode.c
 * 
 * Copyright (C) 2002 Simone Piccardi
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
/****************************************************************
 *
 * Program barcode 
 * CGI for barcode generation
 *
 * Author: Simone Piccardi
 * Jun. 2002
 *
 * Usage: cgi-bin for apache.
 * Called by downloading something like:
 * http://localhost/cgi-bin/barcode?string
 * where string is the code to be converted
 *
 * $Id: BarCode.c,v 1.3 2002/06/23 22:03:28 piccardi Exp $ 
 *
 ****************************************************************/
/* 
 * Include needed headers
 */
#include <sys/types.h>   /* predefined types */
#include <sys/stat.h>    /* stat deinitiions */
#include <unistd.h>      /* include unix standard library */
/* */
#include <stdio.h>	 /* include standard I/O library */
#include <stdlib.h>	 /* include standard library */
#include <string.h>	 /* include string library */
#include <wait.h>	 /* include wait call */
#include <fcntl.h>
#include <assert.h>
#include <time.h>

#include"macros.h"
void WriteMess(char *mess);


/* Program begin */
int main(int argc, char *argv[], char *envp[])
{
/*
 * Variables definition	 
 */
    FILE *file1, *file2, *file3;
    char content[]="Content-type: image/jpeg\n\n";
    /* 
     * Begin
     */
    /* write mime-type to stout */ 
    write(STDOUT_FILENO, content, strlen(content));
    /* convert PDF to JPEG */
    file1 = popen("gs -q -sDEVICE=jpeg -sOutputFile=- -", "w");
    /* convert EPS to PDF*/
    dup2(fileno(file1), STDOUT_FILENO);  /* set epstopdf stdout to file1 */
    file2 = popen("epstopdf --filter", "w");
//    file2 = popen("eps2eps", "w");
    /* create barcode */
    dup2(fileno(file2), STDOUT_FILENO);  /* set barcode stdout to file2 */
    file3 = popen("barcode -E", "w");     
    write(fileno(file3), argv[1], strlen(argv[1]));
    exit(0);
}
/*
 * Routine to produce an HTML error message on output 
 */
void WriteMess(char *mess)
{
    printf("Content-type: text/html\n\n");
    perror(mess);
    printf("<br>\n");
}
